#include <avr/io.h>
#include "tlc5916.h"
#include "usart.h"

void tlc5916_init (void) {
  LE_DDR |= (1<<LE);
  OE_DDR |= (1<<OE);
  OE_HI
  LE_LO
}
void tlc5916_mode (uint8_t newmode) {
  SPI_DISABLE
  // initial state of the pins and
  // 1. clock
  XCK_LO
  LE_LO
  OE_HI
  XCK_HILO
  // 2. clock
  OE_LO
  XCK_HILO
  // 3. clock
  OE_HI
  XCK_HILO
  if (newmode == SPECIAL) {
    // 4. clock
    LE_HI
    XCK_HILO
    // 5. clock
    LE_LO
    XCK_HILO
  } else {
    // 4. clock
    XCK_HILO
    // 5. clock
    XCK_HILO
  }
  SPI_ENABLE
}
void tlc5916_out (uint8_t data, uint8_t device) {
  static uint8_t out[TLC5916_QTY] = OUT_ARRAY_INIT;
  uint8_t i;
  out[device] = data;
  for (i = 0; i < TLC5916_QTY; i++) {
    usart_mspim_transceive (out[i]);
  }
  LE_HILO
}
void tlc5916_cur (uint8_t data, uint8_t device) {
  static uint8_t cur[TLC5916_QTY] = CUR_ARRAY_INIT;
  uint8_t i;
  cur[device] = data;
  tlc5916_mode (SPECIAL);
  for (i = 0; i < TLC5916_QTY; i++) {
    usart_mspim_transceive (cur[i]);
  }
  LE_HILO
  tlc5916_mode (NORMAL);
}
